Create Processor
Run code over every matching event of the stream; it writes into the output streams.
The caller must be able to edit every output stream. The code runs in the sandbox, one call per event, and gets no secrets.
curl --request POST \
--url https://api.example.com/v1/workspaces/{workspace}/streams/{stream_id}/processors \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--data '
{
"code": "<string>",
"output_stream_ids": [
"3c90c3cc-0d44-4b50-8888-8dd25736052a"
],
"event_filter": {
"fields": {},
"kinds": [
"<string>"
]
}
}
'import requests
url = "https://api.example.com/v1/workspaces/{workspace}/streams/{stream_id}/processors"
payload = {
"code": "<string>",
"output_stream_ids": ["3c90c3cc-0d44-4b50-8888-8dd25736052a"],
"event_filter": {
"fields": {},
"kinds": ["<string>"]
}
}
headers = {
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
body: JSON.stringify({
code: '<string>',
output_stream_ids: ['3c90c3cc-0d44-4b50-8888-8dd25736052a'],
event_filter: {fields: {}, kinds: ['<string>']}
})
};
fetch('https://api.example.com/v1/workspaces/{workspace}/streams/{stream_id}/processors', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://api.example.com/v1/workspaces/{workspace}/streams/{stream_id}/processors",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_POSTFIELDS => json_encode([
'code' => '<string>',
'output_stream_ids' => [
'3c90c3cc-0d44-4b50-8888-8dd25736052a'
],
'event_filter' => [
'fields' => [
],
'kinds' => [
'<string>'
]
]
]),
CURLOPT_HTTPHEADER => [
"Authorization: Bearer <token>",
"Content-Type: application/json"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://api.example.com/v1/workspaces/{workspace}/streams/{stream_id}/processors"
payload := strings.NewReader("{\n \"code\": \"<string>\",\n \"output_stream_ids\": [\n \"3c90c3cc-0d44-4b50-8888-8dd25736052a\"\n ],\n \"event_filter\": {\n \"fields\": {},\n \"kinds\": [\n \"<string>\"\n ]\n }\n}")
req, _ := http.NewRequest("POST", url, payload)
req.Header.Add("Authorization", "Bearer <token>")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.post("https://api.example.com/v1/workspaces/{workspace}/streams/{stream_id}/processors")
.header("Authorization", "Bearer <token>")
.header("Content-Type", "application/json")
.body("{\n \"code\": \"<string>\",\n \"output_stream_ids\": [\n \"3c90c3cc-0d44-4b50-8888-8dd25736052a\"\n ],\n \"event_filter\": {\n \"fields\": {},\n \"kinds\": [\n \"<string>\"\n ]\n }\n}")
.asString();require 'uri'
require 'net/http'
url = URI("https://api.example.com/v1/workspaces/{workspace}/streams/{stream_id}/processors")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n \"code\": \"<string>\",\n \"output_stream_ids\": [\n \"3c90c3cc-0d44-4b50-8888-8dd25736052a\"\n ],\n \"event_filter\": {\n \"fields\": {},\n \"kinds\": [\n \"<string>\"\n ]\n }\n}"
response = http.request(request)
puts response.read_body{
"created_at": "2023-11-07T05:31:56Z",
"filter": {},
"id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"kind": "<string>",
"output_stream_ids": [
"3c90c3cc-0d44-4b50-8888-8dd25736052a"
],
"status": "<string>",
"trigger_id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"code": "<string>"
}{
"detail": [
{
"loc": [
"<string>"
],
"msg": "<string>",
"type": "<string>",
"ctx": {},
"input": "<unknown>"
}
]
}Authorizations
Bearer authentication header of the form Bearer <token>, where <token> is your auth token.
Path Parameters
Slug of the workspace the request acts in
120^[a-z0-9]+(?:-[a-z0-9]+)*$Body
Python defining def process(event: dict) -> list[dict] | None. Each returned dict is {stream, kind, data, key?}: stream is an output stream's id or name, kind the new event's kind, data its body. Return None or [] to write nothing. No secrets: the code gets none and every reader of the stream sees it.
1Streams the code may write to; never the input.
1Which events the code runs on; empty runs it on every event.
Show child attributes
Show child attributes
Response
Successful Response
curl --request POST \
--url https://api.example.com/v1/workspaces/{workspace}/streams/{stream_id}/processors \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--data '
{
"code": "<string>",
"output_stream_ids": [
"3c90c3cc-0d44-4b50-8888-8dd25736052a"
],
"event_filter": {
"fields": {},
"kinds": [
"<string>"
]
}
}
'import requests
url = "https://api.example.com/v1/workspaces/{workspace}/streams/{stream_id}/processors"
payload = {
"code": "<string>",
"output_stream_ids": ["3c90c3cc-0d44-4b50-8888-8dd25736052a"],
"event_filter": {
"fields": {},
"kinds": ["<string>"]
}
}
headers = {
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
body: JSON.stringify({
code: '<string>',
output_stream_ids: ['3c90c3cc-0d44-4b50-8888-8dd25736052a'],
event_filter: {fields: {}, kinds: ['<string>']}
})
};
fetch('https://api.example.com/v1/workspaces/{workspace}/streams/{stream_id}/processors', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://api.example.com/v1/workspaces/{workspace}/streams/{stream_id}/processors",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_POSTFIELDS => json_encode([
'code' => '<string>',
'output_stream_ids' => [
'3c90c3cc-0d44-4b50-8888-8dd25736052a'
],
'event_filter' => [
'fields' => [
],
'kinds' => [
'<string>'
]
]
]),
CURLOPT_HTTPHEADER => [
"Authorization: Bearer <token>",
"Content-Type: application/json"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://api.example.com/v1/workspaces/{workspace}/streams/{stream_id}/processors"
payload := strings.NewReader("{\n \"code\": \"<string>\",\n \"output_stream_ids\": [\n \"3c90c3cc-0d44-4b50-8888-8dd25736052a\"\n ],\n \"event_filter\": {\n \"fields\": {},\n \"kinds\": [\n \"<string>\"\n ]\n }\n}")
req, _ := http.NewRequest("POST", url, payload)
req.Header.Add("Authorization", "Bearer <token>")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.post("https://api.example.com/v1/workspaces/{workspace}/streams/{stream_id}/processors")
.header("Authorization", "Bearer <token>")
.header("Content-Type", "application/json")
.body("{\n \"code\": \"<string>\",\n \"output_stream_ids\": [\n \"3c90c3cc-0d44-4b50-8888-8dd25736052a\"\n ],\n \"event_filter\": {\n \"fields\": {},\n \"kinds\": [\n \"<string>\"\n ]\n }\n}")
.asString();require 'uri'
require 'net/http'
url = URI("https://api.example.com/v1/workspaces/{workspace}/streams/{stream_id}/processors")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n \"code\": \"<string>\",\n \"output_stream_ids\": [\n \"3c90c3cc-0d44-4b50-8888-8dd25736052a\"\n ],\n \"event_filter\": {\n \"fields\": {},\n \"kinds\": [\n \"<string>\"\n ]\n }\n}"
response = http.request(request)
puts response.read_body{
"created_at": "2023-11-07T05:31:56Z",
"filter": {},
"id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"kind": "<string>",
"output_stream_ids": [
"3c90c3cc-0d44-4b50-8888-8dd25736052a"
],
"status": "<string>",
"trigger_id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"code": "<string>"
}{
"detail": [
{
"loc": [
"<string>"
],
"msg": "<string>",
"type": "<string>",
"ctx": {},
"input": "<unknown>"
}
]
}